N=10^4;d=5;
A=fc_linalg3D.random.randi(N,d,d,'b',100);
fprintf('[fc_linalg3D] LU factorization with A a %d-by-%d-by-%d array\n',N,d,d)

error=@(o1) max(abs(o1(:)));
PLUerror=@(A,P,L,U) fc_linalg3D.mtimes(P,A)-fc_linalg3D.mtimes(L,U);

[P,L,U]=fc_linalg3D.fact.PALU_Ref(A);
fprintf('* [Ref] Error |P*A-L*U|    : %.4e\n',error(PLUerror(A,P,L,U)));

versions={'Cpt','Mat','Vec'};

for v=versions
  ver=v{1};
  eval(['fun_pLU=@(A) fc_linalg3D.fact.pLU_',ver,'(A);']);
  [p1,L1,U1]=fun_pLU(A);
  P1=fc_linalg3D.fact.PermMatFromArray(p1);
  fprintf('* [%s] Error |P*A-L*U|    : %.4e\n',ver,error(PLUerror(A,P1,L1,U1)));
  fprintf('        Error P with [Ref] : %.4e\n',error(abs(P-P1)));
  fprintf('        Error L with [Ref] : %.4e\n',error(abs(L-L1)));
  fprintf('        Error U with [Ref] : %.4e\n',error(abs(U-U1)));
end
